3 # Copyright (c) 2005 Junio C Hamano
6 test_description='the test framework itself.'
8 ################################################################
9 # It appears that people try to run tests without building...
11 if ! test -x ../notmuch
13 echo >&2 'You do not seem to have built notmuch yet.'
19 ################################################################
21 test_expect_success 'success is reported like this' '
24 test_set_prereq HAVEIT
26 test_expect_success HAVEIT 'test runs if prerequisite is satisfied' '
27 test_have_prereq HAVEIT &&
32 test_expect_success 'tests clean up after themselves' '
33 test_when_finished clean=yes
37 test_expect_code 1 'tests clean up even after a failure' '
38 test_when_finished cleaner=yes &&
42 if test $clean$cleaner != yesyes
44 say "bug in test framework: cleanup commands do not work reliably"
48 test_expect_code 2 'failure to clean up causes the test to fail' '
49 test_when_finished "(exit 2)"
52 # Ensure that all tests are being run
53 test_begin_subtest 'Ensure that all available tests will be run by notmuch-test'
54 eval $(sed -n -e '/^TESTS="$/,/^"$/p' notmuch-test ../notmuch-test)
55 tests_in_suite=$(for i in $TESTS; do echo $i; done | sort)
56 available=$(ls -1 ../ | \
57 sed -r -e "/^(aggregate-results.sh|Makefile|Makefile.local|notmuch-test)/d" \
58 -e "/^(README|test-lib.sh|test-results|tmp.*|valgrind|corpus*)/d" \
59 -e "/^(emacs.expected-output|smtp-dummy|smtp-dummy.c|test-verbose)/d" \
60 -e "/^(test.expected-output|.*~)/d" | sort)
61 test_expect_equal "$tests_in_suite" "$available"
63 EXPECTED=../test.expected-output
64 suppress_diff_date() {
65 sed -e 's/\(.*\-\-\- test-verbose\.4\.\expected\).*/\1/' \
66 -e 's/\(.*\+\+\+ test-verbose\.4\.\output\).*/\1/'
69 test_begin_subtest "Ensure that test output is suppressed unless the test fails"
70 output=$(cd ..; ./test-verbose 2>&1 | suppress_diff_date)
71 expected=$(cat $EXPECTED/test-verbose-no | suppress_diff_date)
72 test_expect_equal "$output" "$expected"
74 test_begin_subtest "Ensure that -v does not suppress test output"
75 output=$(cd ..; ./test-verbose -v 2>&1 | suppress_diff_date)
76 expected=$(cat $EXPECTED/test-verbose-yes | suppress_diff_date)
77 # Do not include the results of test-verbose in totals
78 rm $TEST_DIRECTORY/test-results/test-verbose-*
79 rm -r $TEST_DIRECTORY/tmp.test-verbose
80 test_expect_equal "$output" "$expected"
83 ################################################################
84 # Test mail store prepared in test-lib.sh
87 'test that mail store was created' \
88 'test -d "${MAIL_DIR}"'
91 find "${MAIL_DIR}" -type f -print >should-be-empty
93 'mail store should be empty' \
94 'cmp -s /dev/null should-be-empty'
97 'NOTMUCH_CONFIG is set and points to an existing file' \
98 'test -f "${NOTMUCH_CONFIG}"'
100 test_expect_success \
101 'PATH is set to this repository' \
102 'test "`echo $PATH|cut -f1 -d: | sed -e 's,/test/valgrind/bin$,,'`" = "`dirname ${TEST_DIRECTORY}`"'